package net.sabi.pester;

import danger.app.Application;
import danger.app.Event;
import danger.app.IPCMessage;
import danger.ui.Layout;
import danger.ui.TextField;
import danger.ui.TextInputAlertWindow;
import danger.ui.ScreenWindow;
import danger.ui.StaticText;
import danger.util.DEBUG;
import java.util.Stack;

public class Pester extends Application implements Resources, Commands {
    private static ScreenWindow sAlarmListWindow;
    private static Stack sAlarmStack;

    public Pester() {
	sAlarmListWindow = (ScreenWindow)getResources().getScreen(ID_ALARM_LIST_SCREEN);
	sAlarmListWindow.show();
	sAlarmStack = new Stack();
    }

    public boolean receiveEvent(Event e) {
	switch (e.type) {
	case Event.EVENT_ALARM:
	    Alarm alarm = (Alarm)e.argument;
	    TextInputAlertWindow alert = getTextInputAlert(ID_ALARM_ALERT, this);
	    alert.setTitle(alarm.getDateTimeString());
	    alert.setMessage(alarm.getMessage());
	    alert.setShowTone(alarm.getAlert());
	    alert.disableButtonOnEmptyField(ID_SNOOZE_BUTTON, ID_SNOOZE_MINUTES);
	    alert.setShowCancel(false);
	    alert.show(TextInputAlertWindow.SYSTEM_ALERT_TYPE_ALARM);
	    sAlarmStack.push(alarm);
	    return true;
	case EVENT_SET_ALARM:
	    AlarmSetDialog alarmSetDialog = AlarmSetDialog.getDialog();
	    alarmSetDialog.setWindowStyle(AlarmSetDialog.SYSTEM_DIALOG_STYLE);
	    alarmSetDialog.editAlarm((Alarm)sAlarmStack.pop(),false);
	    return true;
	case EVENT_SNOOZE_ALARM:
	    String snoozeMinutesString =
		TextInputAlertWindow.
		getTextFieldValue((IPCMessage)e.argument,
				  ID_SNOOZE_MINUTES);
	    int snoozeMinutes = Integer.parseInt(snoozeMinutesString);
	    ((Alarm)sAlarmStack.pop()).snoozeForMinutes(snoozeMinutes);
	    return true;
	case EVENT_DISMISS_ALARM:
	    ((Alarm)sAlarmStack.pop()).dismiss();
	    return true;
	}
	return super.receiveEvent(e);
    }
}
